#!/usr/bin/python3
import socket
import os
import threading
import urllib.request


# Modified for dual NIC
for root, dirs, files in os.walk('/opt/director'):
    for d in dirs:
        os.chmod(os.path.join(root,d),0o777)
    for f in files:
        os.chmod(os.path.join(root,f),0o777)

# Hardware can report the NIC's as different names as a result of the BIOS so we need to find the name of the actual LAN NIC
# NUC LAN NIC = enp2s0
NIC = os.popen('ls /sys/class/net').read()
NIC = NIC.split('\n')
USBNIC = NIC
for line in NIC:
    if 'lo' not in line and 'vir' not in line and 'wl' not in line and 'enx' not in line:
        NIC = line
        break

# Check for USB NIC
USBNICFOUND = ''
for line in USBNIC:
    if 'lo' not in line and 'vir' not in line and 'wl' not in line and NIC not in line:
        USBNICFOUND = line
        break

# Make sure /etc/issue has the correct NIC appended after '\4' You must log into the system by browsing to the controllers IP address at \4{enp2s0}
FILESTRING = ''
FILENAME = '/etc/issue'
correctNIC = False

with open(FILENAME) as FILE:
    for line in FILE.readlines():
        if 'You must log into the system by browsing to the controllers IP address at \\4{' + NIC + '}' in line:
            correctNIC = True
FILE.close()

if not correctNIC:
    with open(FILENAME) as FILE:
        for line in FILE.readlines():
            if 'You must log into the system by browsing to the controllers IP address at' in line:
                line = 'You must log into the system by browsing to the controllers IP address at \\4{' + NIC + '}\n'

            FILESTRING += line

    FILE.close()
    FILE = open(FILENAME, 'w')
    FILE.write(FILESTRING)
    FILE.close()
    os.system('reboot')


# make sure the devices NIC name is correct after a disc image has been applied containing an interfaces file
INTERFACE = open('/etc/network/interfaces', "r")
INTERFACE = INTERFACE.readlines()
INTERFACE = INTERFACE[3]
INTERFACE = INTERFACE.split(" ")
INTERFACE = INTERFACE[1].strip()

if NIC != INTERFACE:
    if USBNICFOUND:
        os.system('/opt/director/config.sh 192.168.1.1 255.255.255.0 192.168.1.254 192.168.1.0 192.168.1.255 169.254.1.1 255.255.0.0')
    else:
        os.system('/opt/director/config.sh 169.254.1.1 255.255.0.0 169.254.1.254 169.254.0.0 169.254.255.255')
    os.system('reboot')


# UDP Broadcast
UDP_IP = "255.255.255.255"
UDP_PORT = 9132
SOCK = socket.socket(socket.AF_INET, socket.SOCK_DGRAM)
SOCK.setsockopt(socket.SOL_SOCKET, socket.SO_BROADCAST, 1)

SYSIP = os.popen("hostname -I | awk '{print $1}'").read()
SYSIP = SYSIP[:-1]
SYSIPOLD = SYSIP


def beacon():
    global SYSIP
    global SYSIPOLD

# if DHCP changed IP then the beacon IP (SYSIP) would not be updated once it had an IP address
#    if (not SYSIP or SYSIP == '169.254.1.1'):
#        SYSIP = os.popen('ifconfig ' + NIC + ' | grep "inet " | cut -d" " -f10').read()
#        SYSIP = SYSIP[:-1]

    if not SYSIP:
        SYSIP = os.popen("hostname -I | awk '{print $1}'").read()
        SYSIP = SYSIP[:-1]
        SYSIPOLD = SYSIP

    if SYSIP:
        IPtmp = SYSIP.split(".")
        if (IPtmp[0] == '169' and IPtmp[1] == '254'):
            SYSIP = os.popen("hostname -I | awk '{print $1}'").read()
            SYSIP = SYSIP[:-1]
            if SYSIP != SYSIPOLD:
                SYSIPOLD = SYSIP
                call = urllib.request.urlopen("http://127.0.0.1/api/updateNetwork").read()

        beacon_text = "U0RWb0U=[" + SYSIP + "]"
        beacon_text = beacon_text.encode('utf-8')
        SOCK.sendto(beacon_text, (UDP_IP, UDP_PORT))
    beacon_timer = threading.Timer(10, beacon)
    beacon_timer.start()

beacon()
