#!/usr/bin/python3
import os
import os.path
import socket
import re
import glob

#must = either False or True
LIBERTY = True

# NUC LAN NIC = enp2s0
NIC = os.popen('ip a').read()
NIC = NIC.split('\n')
NICFOUND = ''
USBNICFOUND = ''
NICID = 1
for line in NIC:
    if str(NICID) + ': ' in line:
        if 'lo' not in line and 'vir' not in line and 'wl' not in line:
            m = re.search(str(NICID) + ': (.+?):', line)
            if NICFOUND:
                USBNICFOUND = m.group(1)
                break
            else:
                NICFOUND = m.group(1)
        NICID = NICID + 1

FILESTRING = 'auto lo\n'
FILESTRING += '\n'
FILESTRING += 'iface lo inet loopback\n'
FILESTRING += 'allow-hotplug ' + NICFOUND + '\n'
FILESTRING += '\n'
FILESTRING += 'iface ' + NICFOUND + ' inet static\n'
if USBNICFOUND:
    FILESTRING += 'address 192.168.1.1\n'
    FILESTRING += 'netmask 255.255.255.0\n'
    FILESTRING += 'network 192.168.0.0\n'
    FILESTRING += 'broadcast 192.168.1.255\n'
    FILESTRING += 'gateway 192.168.1.254\n'
else:
    FILESTRING += 'address 169.254.1.1\n'
    FILESTRING += 'netmask 255.255.0.0\n'
    FILESTRING += 'network 169.254.0.0\n'
    FILESTRING += 'broadcast 169.254.255.255\n'
    FILESTRING += 'gateway 169.254.1.254\n'
FILESTRING += 'dns-nameservers 8.8.8.8\n'
FILESTRING += '\n'

if USBNICFOUND:
    FILESTRING += 'auto ' + USBNICFOUND + '\n'
    FILESTRING += 'allow-hotplug ' + USBNICFOUND + '\n'
    FILESTRING += 'iface ' + USBNICFOUND + ' inet static\n'
    FILESTRING += 'address 169.254.1.1\n'
    FILESTRING += 'netmask 255.255.0.0\n'
    FILESTRING += 'network 169.254.0.0\n'
    FILESTRING += 'broadcast 169.254.255.255\n'
    FILESTRING += '\n'

FILENAME = '/opt/director/tmp'
FILE = open(FILENAME, 'w')
FILE.write(FILESTRING)
FILE.close()

# restore network to default
os.system('mv /etc/network/interfaces /etc/network/interfaces.bak')
os.system('mv /opt/director/tmp /etc/network/interfaces')

DIR = '/var/lib/dhcp/'
if os.path.isdir(DIR):
    if os.listdir(DIR):
        os.system('rm ' + DIR + '*')

# clear DNS
FILESTRING = 'nameserver 8.8.8.8'
FILENAME = '/etc/resolv.conf'
FILE = open(FILENAME, 'w')
FILE.write(FILESTRING)
FILE.close()

# restore system defaults config.json
if os.path.isfile('/opt/director/config.json'):
    os.remove('/opt/director/config.json')

FILESTRING = '{'
FILESTRING += '  "logLevel" : "INFO",\n'
FILESTRING += '  "logConsole" : true,\n'
FILESTRING += '  "devices.dataRefreshTime" : 30000,\n'
FILESTRING += '  "devices.statusRefreshTime" : 5000,\n'
if LIBERTY:
    FILESTRING += '  "layout.file" : "liberty.json",\n'
else:
    FILESTRING += '  "layout.file" : "default.json",\n'
FILESTRING += '  "devices.udpWaitTimeout" : 250,\n'
FILESTRING += '  "devices.telnetTimeout" : -1,\n'
FILESTRING += '  "devices.loginDelay" : 1000,\n'
FILESTRING += '  "devices.telnetReadTimeout" : 3000,\n'
FILESTRING += '  "devices.telnetBusyTimeout" : 3000,\n'
FILESTRING += '  "matrix.subscriptionFetchInitialDelay" : 500,\n'
FILESTRING += '  "matrix.subscriptionFetchDelay" : 500,\n'
FILESTRING += '  "matrix.subscriptionFetchCount" : 5,\n'
FILESTRING += '  "identify.onOffInterval" : 30,\n'
FILESTRING += '  "consoleConnections" : 0,\n'
FILESTRING += '  "leaveSubscriptionsSystemStart" : false,\n'
FILESTRING += '  "defaultMulticastRangeStart" : 239,\n'
FILESTRING += '  "multicast.rangeStart" : 239,\n'
FILESTRING += '  "restart" : "/opt/director/restart.sh",\n'
FILESTRING += '  "reboot" : "/opt/director/reboot.sh",\n'
FILESTRING += '  "generateInfoFile" : "/opt/director/info.sh",\n'
FILESTRING += '  "infoFilePath" : "/opt/director/infoData",\n'
FILESTRING += '  "setInfoFile" : "/opt/director/config.sh",\n'
FILESTRING += '  "deleteInfoFile" : "/opt/director/delete.sh",\n'
FILESTRING += '  "testDhcpFilePath" : "/opt/director/testDHCP.sh",\n'
FILESTRING += '  "testDhcpOutputFilePath" : "/opt/director/infoDHCP",\n'
FILESTRING += '  "defaultDhcp" : false,\n'
if LIBERTY:
    FILESTRING += '  "defaultHostname" : "Arranger",\n'
else:
    FILESTRING += '  "defaultHostname" : "Director",\n'
FILESTRING += '  "rebootTime" : 90,\n'
FILESTRING += '  "directorRestartTime" : 20,\n'
FILESTRING += '  "oemNamePrefixMap" : {\n'
if LIBERTY:
    FILESTRING += '    "IPE5000DNT" : "IPEX5001-D",\n'
    FILESTRING += '    "IPE5000" : "IPEX5001",\n'
    FILESTRING += '    "IPD5000" : "IPEX5002",\n'
    FILESTRING += '    "IPE5000W" : "IPEX5001-WP"\n'
else:
    FILESTRING += '    "IPE5000DNT" : "TH2001DTE",\n'
    FILESTRING += '    "IPE5000" : "TH2001E",\n'
    FILESTRING += '    "IPD5000" : "TH2002D",\n'
    FILESTRING += '    "IPE5000W" : "TH2001WP"\n'
FILESTRING += '  },\n'
FILESTRING += '  "validModels" : [ "IPE5000", "IPD5000", "IPE5000DNT", "IPE5000W" ],\n'
FILESTRING += '  "inactiveSessionTimeout" : 15,\n'
FILESTRING += '  "serial_timeout" : 3000,\n'
FILESTRING += '  "tcpSecured" : false,\n'
FILESTRING += '  "tcpConnectionTimeout" : 120,\n'
FILESTRING += '  "tcp_command_timeout" : 3000,\n'
FILESTRING += '  "tcp_command_timeout_gap" : "300",\n'
FILESTRING += '  "gc_command_timeout" : 5000,\n'
FILESTRING += '  "gc_command_timeout_gap" : "500",\n'
FILESTRING += '  "ntp" : "/opt/director/ntp.sh",\n'
FILESTRING += '  "setNtp" : "/opt/director/set-ntp.sh",\n'
FILESTRING += '  "setTime" : "/opt/director/time.sh",\n'
FILESTRING += '  "dbRetentionPeriod" : 1,\n'
FILESTRING += '  "firmwareUpdateMaxDeviceCount" : 50,\n'
FILESTRING += '  "bezelLimit" : 20,\n'
FILESTRING += '  "vw_defaultHeightWidthRatio" : 0.5,\n'
FILESTRING += '  "vw_minWidth" : 500.0,\n'
FILESTRING += '  "email_settings" : {\n'
FILESTRING += '    "port" : 25,\n'
FILESTRING += '    "emailTo" : "",\n'
FILESTRING += '    "emailCc" : "",\n'
FILESTRING += '    "mailServer" : "",\n'
FILESTRING += '    "fromEmail" : "",\n'
FILESTRING += '    "userName" : "",\n'
FILESTRING += '    "password" : "",\n'
FILESTRING += '    "secureConnection" : false,\n'
FILESTRING += '    "authentication" : "NONE"\n'
FILESTRING += '  },\n'
FILESTRING += '  "customURL" : false,\n'
FILESTRING += '  "debounce" : "100",\n'
if LIBERTY:
    FILESTRING += '  "dateFormat" : "MM-dd-yyyy",\n'
else:
    FILESTRING += '  "dateFormat" : "dd-MM-yyyy",\n'
FILESTRING += '  "timeFormat" : "24H",\n'
FILESTRING += '  "deviceNameMaxLength" : 23,\n'
FILESTRING += '  "jpgImagePreview" : true,\n'
FILESTRING += '  "previewCacheInterval" : 10,\n'
if USBNICFOUND:
    FILESTRING += '  "apiControllerIp" : "192.168.1.1",\n'
    FILESTRING += '  "apiControllerSubnet" : "255.255.255.0",\n'
    FILESTRING += '  "apiControllerGateway" : "192.168.1.254",\n'
    FILESTRING += '  "defaultIpAddr" : "192.168.1.1",\n'
    FILESTRING += '  "defaultGateway" : "192.168.1.254",\n'
    FILESTRING += '  "defaultMask" : "255.255.255.0",\n'
    FILESTRING += '  "apiControllerIp2" : "169.254.1.1",\n'
    FILESTRING += '  "apiControllerSubnet2" : "255.255.0.0",\n'
    FILESTRING += '  "defaultIpAddr2" : "169.254.1.1",\n'
    FILESTRING += '  "defaultMask2" : "255.255.0.0",\n'
else:
    FILESTRING += '  "apiControllerIp" : "169.254.1.1",\n'
    FILESTRING += '  "apiControllerSubnet" : "255.255.0.0",\n'
    FILESTRING += '  "apiControllerGateway" : "169.254.1.254",\n'
    FILESTRING += '  "defaultIpAddr" : "169.254.1.1",\n'
    FILESTRING += '  "defaultGateway" : "169.254.1.254",\n'
    FILESTRING += '  "defaultMask" : "255.255.0.0",\n'
FILESTRING += '  "defaultDns" : "8.8.8.8",\n'
FILESTRING += '  "apiControllerDns" : "8.8.8.8",\n'
FILESTRING += '  "apiControllerDHCP" : false,\n'
FILESTRING += '  "companyName" : "",\n'
FILESTRING += '  "registrationKey" : "",\n'
FILESTRING += '  "language" : "en"\n'
FILESTRING += '}\n'
FILESTRING += '\n'

FILENAME = '/opt/director/config.json'
FILE = open(FILENAME, 'w')
FILE.write(FILESTRING)
FILE.close()

if os.path.isfile('/opt/director/config.bak'):
    os.remove('/opt/director/config.bak')

# delete logs
DIR = '/opt/director/logs/'
if os.path.isdir(DIR):
    if os.listdir(DIR):
        FILELIST = os.listdir(DIR)
        for NAME in FILELIST:
            os.remove(DIR + NAME)

# delete analytics database
DIR = '/opt/director/data/db/'
if os.path.isdir(DIR):
    if os.listdir(DIR):
        os.system('rm -r /opt/director/data/db/*')
    os.rmdir('/opt/director/data/db')

# delete QRcode results
DIR = '/opt/director/data/qrresults/'
if os.path.isdir(DIR):
    if os.listdir(DIR):
        os.system('rm -r ' + DIR + '*')

# delete UI updates
DIR = '/opt/director/update/'
if os.path.isdir(DIR):
    if os.listdir(DIR):
        FILELIST = os.listdir(DIR)
        for NAME in FILELIST:
            os.remove(DIR + NAME)

# delete cached preview images
DIR = '/opt/director/data/preview/'
if os.path.isdir(DIR):
    if os.listdir(DIR):
        os.system('rm -r ' + DIR + '*')

# delete all user data files

if os.path.isfile('/opt/director/data/sendSerial.json'):
    os.remove('/opt/director/data/sendSerial.json')

if os.path.isfile('/opt/director/data/sendTcp.json'):
    os.remove('/opt/director/data/sendTcp.json')

if os.path.isfile('/opt/director/data/userVar.json'):
    os.remove('/opt/director/data/userVar.json')

if os.path.isfile('/opt/director/data/globalcache.json'):
    os.remove('/opt/director/data/globalcache.json')

if os.path.isfile('/opt/director/data/setListener.json'):
    os.remove('/opt/director/data/setListener.json')

DIR = '/opt/director/data/controlui/'
if os.path.isdir(DIR):
    if os.listdir(DIR):
        os.system('rm -r /opt/director/data/controlui/*')
        os.system('rmdir /opt/director/data/controlui')

DIR = '/opt/director/data/presets/'
if os.path.isdir(DIR):
    if os.listdir(DIR):
        FILELIST = os.listdir(DIR)
        for NAME in FILELIST:
            os.remove(DIR + NAME)
        os.system('cp /opt/director/data/demopresets/* /opt/director/data/presets/')

if os.path.isfile('/opt/director/data/anycontrolSettings.json'):
    os.remove('/opt/director/data/anycontrolSettings.json')

if os.path.isfile('/opt/director/data/oemMappings.json'):
    os.remove('/opt/director/data/oemMappings.json')

if os.path.isfile('/opt/director/data/presenterSettings.json'):
    os.remove('/opt/director/data/presenterSettings.json')

if os.path.isfile('/opt/director/data/presetEvents.json'):
    os.remove('/opt/director/data/presetEvents.json')

if os.path.isfile('/opt/director/data/eventSettings.json'):
    os.remove('/opt/director/data/eventSettings.json')

if os.path.isfile('/opt/director/data/permission.json'):
    os.remove('/opt/director/data/permission.json')

if os.path.isfile('/opt/director/data/autoDecoders.json'):
    os.remove('/opt/director/data/autoDecoders.json')

if os.path.isfile('/opt/director/data/reporter/reporterDetails.json'):
    os.remove('/opt/director/data/reporter/reporterDetails.json')

if os.path.isfile('/opt/director/data/director_data.json.save'):
    os.remove('/opt/director/data/director_data.json.save')

DIR = '/opt/director/manuals/user/'
if os.path.isdir(DIR):
    if os.listdir(DIR):
        list_of_files = glob.glob(DIR + '*')
        latest_file = max(list_of_files, key=os.path.getctime)
        FILELIST = os.listdir(DIR)
        for NAME in FILELIST:
            if DIR + NAME != latest_file:
                os.remove(DIR + NAME)

DIR = '/opt/director/manuals/command/'
if os.path.isdir(DIR):
    if os.listdir(DIR):
        list_of_files = glob.glob(DIR + '*')
        latest_file = max(list_of_files, key=os.path.getctime)
        FILELIST = os.listdir(DIR)
        for NAME in FILELIST:
            if DIR + NAME != latest_file:
                os.remove(DIR + NAME)

# restore default user admin/admin
if os.path.isfile('/opt/director/data/director_data.json'):
    os.remove('/opt/director/data/director_data.json')

FILESTRING = '{\n'
FILESTRING += '  "users": [\n'
FILESTRING += '    {\n'
FILESTRING += '      "id": "1",\n'
FILESTRING += '      "created": "2020-06-23T06:08:11.080+0000",\n'
FILESTRING += '      "updated": "2020-06-23T06:08:11.080+0000",\n'
FILESTRING += '      "login": "admin",\n'
FILESTRING += '      "password": "ai2p53Zx2V63w03;y2no",\n'
FILESTRING += '      "userType": "ADMIN",\n'
FILESTRING += '      "changePasswordOnLogin": true,\n'
FILESTRING += '      "groupAccessType": null,\n'
FILESTRING += '      "groups": [],\n'
FILESTRING += '      "allowedSections": null\n'
FILESTRING += '    }\n'
FILESTRING += '  ],\n'
FILESTRING += '  "nextIds": {\n'
FILESTRING += '    "user": 1\n'
FILESTRING += '  }\n'
FILESTRING += '}'

FILENAME = '/opt/director/data/director_data.json'
FILE = open(FILENAME, 'w')
FILE.write(FILESTRING)
FILE.close()

# set default hostname
# defaultname = "xxxxx"
DEFAULTNAME = "Director"
if LIBERTY:
    DEFAULTNAME = "Arranger"
NAMEFOUND = False

# check for a custom hostname
FILENAME = "/opt/director/custom/hostname.txt"
if os.path.isfile(FILENAME):
    HOSTNAMEFILE = open(FILENAME, 'r')
    DEFAULTNAME = HOSTNAMEFILE.readline()
    HOSTNAMEFILE.close()
    NAMEFOUND = True

# if no custom hostname get the default hostname from config.json
if not NAMEFOUND:
    FILENAME = "/opt/director/config.json"
    if os.path.isfile(FILENAME):
        with open(FILENAME) as FILE:
            for line in FILE.readlines():
                if 'defaultHostname' in line:
                    m = re.search('"defaultHostname" : "(.+?)"', line)
                    DEFAULTNAME = m.group(1)

# get the current hostname
CURRENTHOSTNAME = socket.gethostname()

# write the default hostname to /etc/hostname
FILENAME = "/etc/hostname"
FILE = open(FILENAME, "w")
FILE.write(DEFAULTNAME)
FILE.close()

# /etc/hosts
# 127.0.0.1	localhost
# 127.0.1.1	xxxxx

# change default hostname in /etc/hosts
FILESTRING = ""
FILENAME = "/etc/hosts"
with open(FILENAME) as FILE:
    for line in FILE.readlines():
        if '127.0.1.1\t' + CURRENTHOSTNAME in line:
            line = '127.0.1.1\t' + DEFAULTNAME + '\n'
        FILESTRING += line
FILE.close()
FILE = open(FILENAME, 'w')
FILE.write(FILESTRING)
FILE.close()

# set default timezone
TIMEZONE = "Australia/Melbourne"
if LIBERTY:
    TIMEZONE = "America/Los_Angeles"
os.system('timedatectl set-timezone '+ TIMEZONE)

# reboot with default data
os.system('reboot')
