#!/usr/bin/python3
import socket
import os
import threading

# Hardware can report the NIC's as different names as a result of the BIOS so we need to find the name of the actual LAN NIC
# NUC LAN NIC = enp2s0
NIC = os.popen('ls /sys/class/net').read()
NIC = NIC.split('\n')
for line in NIC:
    if 'lo' not in line and 'vir' not in line and 'wl' not in line:
        NIC = line
        break

# make sure the devices NIC name is correct after a disc image has been applied containing an interfaces file
INTERFACE = open('/etc/network/interfaces', "r")
INTERFACE = INTERFACE.readlines()
INTERFACE = INTERFACE[3]
INTERFACE = INTERFACE.split(" ")
INTERFACE = INTERFACE[1].strip()

if NIC != INTERFACE:
    os.system('/opt/director/config.sh 169.254.1.1 255.255.0.0 169.254.1.254 169.254.0.0 169.254.255.255')
    os.system('reboot')


# UDP Broadcast
UDP_IP = "255.255.255.255"
UDP_PORT = 9132
SOCK = socket.socket(socket.AF_INET, socket.SOCK_DGRAM)
SOCK.setsockopt(socket.SOL_SOCKET, socket.SO_BROADCAST, 1)

SYSIP = ''


def beacon():
    global SYSIP
# if DHCP changed IP then the beacon IP (SYSIP) would not be updated once it had an IP address
#    if (not SYSIP or SYSIP == '169.254.1.1'):
#        SYSIP = os.popen('ifconfig ' + NIC + ' | grep "inet " | cut -d" " -f10').read()
#        SYSIP = SYSIP[:-1]
    SYSIP = os.popen("hostname -I | awk '{print $1}'").read()
    SYSIP = SYSIP[:-1]
    beacon_text = "LZ550DS[" + SYSIP + "]"
    beacon_text = beacon_text.encode('utf-8')
    beacon_timer = threading.Timer(10, beacon)
    beacon_timer.start()
    SOCK.sendto(beacon_text, (UDP_IP, UDP_PORT))


beacon()
