#!/usr/bin/python3
import os
import os.path

# Hardware can report the NIC's as different names as a result of the BIOS so we need to find the name of the actual LAN NIC
# NUC LAN NIC = enp2s0
NIC = os.popen('ls /sys/class/net').read()
NIC = NIC.split('\n')
for line in NIC:
    if 'lo' not in line and 'vir' not in line and 'wl' not in line:
        NIC = line
        break

FILESTRING = 'auto lo\n'
FILESTRING += '\n'
FILESTRING += 'iface lo inet loopback\n'
FILESTRING += 'allow-hotplug ' + NIC + '\n'
FILESTRING += '\n'
FILESTRING += 'iface ' + NIC + ' inet static\n'
FILESTRING += 'address 169.254.1.1\n'
FILESTRING += 'netmask 255.255.0.0\n'
FILESTRING += 'network 169.254.0.0\n'
FILESTRING += 'broadcast 169.254.255.255\n'
FILESTRING += 'gateway 169.254.1.254\n'
FILESTRING += '\n'

FILENAME = '/opt/director/tmp'
FILE = open(FILENAME, 'w')
FILE.write(FILESTRING)
FILE.close()

# restore network to default
os.system('mv /etc/network/interfaces /etc/network/interfaces.bak')
os.system('mv /opt/director/tmp /etc/network/interfaces')

DIR = '/var/lib/dhcp/'
if os.path.isdir(DIR):
    if os.listdir(DIR):
        os.system('rm ' + DIR + '*')

# restore system defaults config.json
os.system('rm /opt/director/config.json')

FILESTRING = '{'
FILESTRING += '"serverIp":"127.0.0.1",'
FILESTRING += '"serverPort":"6970",'
FILESTRING += '"P_VIDEO_WIDTH":"1920",'
FILESTRING += '"P_VIDEO_HEIGHT":"1080",'
FILESTRING += '"P_FPS":"60",'
FILESTRING += '"setTime":"/opt/director/time.sh",'
FILESTRING += '"reboot":"/opt/director/reboot.sh",'
FILESTRING += '"stopApi":"/opt/director/api_stop.sh",'
FILESTRING += '"runApi":"/opt/director/api_start.sh",'
FILESTRING += '"generateInfoFile":"/opt/director/info.sh",'
FILESTRING += '"infoFilePath":"/opt/director/infoData",'
FILESTRING += '"setInfoFile":"/opt/director/config.sh",'
FILESTRING += '"deleteInfoFile":"/opt/director/delete.sh",'
FILESTRING += '"language":"en",'
FILESTRING += '"apiControllerIp":"169.254.1.1",'
FILESTRING += '"restart":"/opt/director/restart.sh",'
FILESTRING += '"defaultIpAddr":"169.254.1.1",'
FILESTRING += '"defaultMask":"255.255.0.0",'
FILESTRING += '"defaultGateway":"169.254.1.254",'
FILESTRING += '"defaultdhcp":"false",'
FILESTRING += '"device_data_refresh":"30000",'
FILESTRING += '"usb_data_refresh":"10000",'
FILESTRING += '"usb_compatible_revision":"1.8.5",'
FILESTRING += '"verify_scaler":"false",'
FILESTRING += '"received_string_count":"10",'
FILESTRING += '"temperatureLimit":"85",'
FILESTRING += '"apiControllerSubnet":"255.255.0.0",'
FILESTRING += '"apiControllerGateway":"169.254.1.254",'
FILESTRING += '"showCommands":"false",'
FILESTRING += '"rebootTime":"60",'
FILESTRING += '"companyName":"",'
FILESTRING += '"registrationKey":"",'
FILESTRING += '"tcpSecured":"false",'
FILESTRING += '"leaveSubscriptionsSystemStart":"false",'
FILESTRING += '"consoleConnections":"0",'
FILESTRING += '"apiControllerDHCP":"false",'
FILESTRING += '"tcpConnectionTimeout":"30",'
FILESTRING += '"leaveSubscriptionsEnabled":"false",'
FILESTRING += '"bezelLimit":"20",'
FILESTRING += '"showPresenterStrings":"false",'
FILESTRING += '"gc_command_timeout":"5000",'
FILESTRING += '"dbRetentionPeriod":"1",'
FILESTRING += '"logLevel":"INFO",'
FILESTRING += '"mail_server":"",'
FILESTRING += '"from_email":"",'
FILESTRING += '"user_name":"",'
FILESTRING += '"password":"",'
FILESTRING += '"port":"",'
FILESTRING += '"secure_connection":"false",'
FILESTRING += '"securityKey":"",'
FILESTRING += '"tcpSecurityKey":"",'
FILESTRING += '"temperatureFormat":"celsius",'
FILESTRING += '"serial_timeout":"3000",'
FILESTRING += '"hysteresis":"3",'
FILESTRING += '"initialDataTime":"30000"'
FILESTRING += '}'
FILESTRING += '\n'

FILENAME = '/opt/director/config.json'
FILE = open(FILENAME, 'w')
FILE.write(FILESTRING)
FILE.close()

# delete logs
DIR = '/opt/director/logs/'
if os.path.isdir(DIR):
    if os.listdir(DIR):
        FILELIST = os.listdir(DIR)
        for NAME in FILELIST:
            os.remove(DIR + NAME)

# delete analytics database
DIR = '/opt/director/data/db/'
if os.path.isdir(DIR):
    if os.listdir(DIR):
        os.system('rm -r /opt/director/data/db/*')
    os.rmdir('/opt/director/data/db')

# delete UI updates
DIR = '/opt/director/update/'
if os.path.isdir(DIR):
    if os.listdir(DIR):
        FILELIST = os.listdir(DIR)
        for NAME in FILELIST:
            os.remove(DIR + NAME)

# delete BlueRiver updates
DIR = '/opt/director/updatelowlevel/'
if os.path.isdir(DIR):
    if os.listdir(DIR):
        FILELIST = os.listdir(DIR)
        for NAME in FILELIST:
            os.remove(DIR + NAME)

# delete firmware updates
DIR = '/opt/api/update/'
if os.path.isdir(DIR):
    if os.listdir(DIR):
        FILELIST = os.listdir(DIR)
        for NAME in FILELIST:
            os.remove(DIR + NAME)

# delete all user data files
if os.path.isfile('/opt/director/data/group/group.json'):
    os.remove('/opt/director/data/group/group.json')

DIR = '/opt/director/data/controlui/'
if os.path.isdir(DIR):
    if os.listdir(DIR):
        os.system('rm -r /opt/director/data/controlui/*')
        os.system('rmdir /opt/director/data/controlui')

DIR = '/opt/director/data/presets/'
if os.path.isdir(DIR):
    if os.listdir(DIR):
        FILELIST = os.listdir(DIR)
        for NAME in FILELIST:
            os.remove(DIR + NAME)
    os.system('cp /opt/director/data/demopresets/* /opt/director/data/presets/')

if os.path.isfile('/opt/director/data/anycontrolSettings.json'):
    os.remove('/opt/director/data/anycontrolSettings.json')

if os.path.isfile('/opt/director/data/oemMappings.json'):
    os.remove('/opt/director/data/oemMappings.json')

if os.path.isfile('/opt/director/data/presenterSettings.json'):
    os.remove('/opt/director/data/presenterSettings.json')

if os.path.isfile('/opt/director/data/presetEvents.json'):
    os.remove('/opt/director/data/presetEvents.json')

if os.path.isfile('/opt/director/data/eventSettings.json'):
    os.remove('/opt/director/data/eventSettings.json')

if os.path.isfile('/opt/director/data/users.json'):
    os.remove('/opt/director/data/users.json')

if os.path.isfile('/opt/director/data/multicastManual.json'):
    os.remove('/opt/director/data/multicastManual.json')

if os.path.isfile('/opt/director/data/multicast/multicastData.json'):
    os.remove('/opt/director/data/multicast/multicastData.json')

if os.path.isfile('/opt/director/data/permission.json'):
    os.remove('/opt/director/data/permission.json')

if os.path.isfile('/opt/director/data/autoDecoders.json'):
    os.remove('/opt/director/data/autoDecoders.json')

if os.path.isfile('/opt/director/data/reporter/reporterDetails.json'):
    os.remove('/opt/director/data/reporter/reporterDetails.json')

# add default user admin/admin
FILESTRING = '{'
FILESTRING += '"password":"rc2K53Rx2b63F03Wy26u",'
FILESTRING += '"userType":"ADMIN",'
FILESTRING += '"username":"admin"'
FILESTRING += '}'

FILENAME = '/opt/director/data/users.json'
FILE = open(FILENAME, 'w')
FILE.write(FILESTRING)
FILE.close()

# write the default multicast configuration data and log level to the blueriver.conf FILE
FILESTRING = ''
FILENAME = '/opt/api/blueriver.conf'
with open(FILENAME) as FILE:
    for line in FILE.readlines():
        if 'multicast_range_start' in line:
            line = 'multicast_range_start = 224.1.1.1\n'
        if 'multicast_range_end' in line:
            line = 'multicast_range_end = 224.1.3.255\n'
        if 'multicast_all_tx' in line:
            line = 'multicast_all_tx = 224.1.1.253\n'
        if 'multicast_all_rx' in line:
            line = 'multicast_all_rx = 224.1.1.254\n'
        if 'logfile_log_level' in line:
            line = 'logfile_log_level    = MESSAGE\n'

        FILESTRING += line

FILE.close()
FILE = open(FILENAME, 'w')
FILE.write(FILESTRING)
FILE.close()

# reboot with default data
os.system('reboot')
