#!/usr/bin/python
import os
import time
import re
from evdev import InputDevice, list_devices

DEVICES = [InputDevice(fn) for fn in list_devices()]
EVENT_ID = -1

# /dev/input/event0       PixArt HP USB Optical Mouse
# /dev/input/event12      HDA Intel PCH HDMI/DP,pcm=3
# /dev/input/event11      HDA Intel PCH Front Headphone Surround
# /dev/input/event10      HDA Intel PCH Headphone Front
# /dev/input/event9       HDA Intel PCH Mic
# /dev/input/event8       HDA Digital PCBeep
# /dev/input/event7       Video Bus
# /dev/input/event6       PC Speaker
# /dev/input/event5       ITE8713 CIR transceiver
# /dev/input/event4       Power Button
# /dev/input/event3       Sleep Button
# /dev/input/event2       Lid Switch
# /dev/input/event1       LITE-ON Technology USB NetVista Full Width Keyboard.


# find the correct event ID
for DEVICE in DEVICES:
    if DEVICE.name.find('HDA Intel PCH Headphone Front') != -1:
        EVENT_ID = str(map(int, re.findall(r'\d+', DEVICE.fn)))
        EVENT_ID = int(EVENT_ID[EVENT_ID.find("[")+1:EVENT_ID.find("]")])

if EVENT_ID != -1:
    DEVICE = InputDevice('/dev/input/event{}'.format(EVENT_ID))
    DEVICE.grab()
    START_TIME = 0
    for event in DEVICE.read_loop():
        if event.type == 5:
            if START_TIME == 0:
                START_TIME = time.time()
            else:
                endTime = time.time()
                runTime = (endTime - START_TIME)
                if runTime > 5:
                    START_TIME = 0
                    os.system('/opt/director/default.sh')
                else:
                    START_TIME = 0
