#!/usr/bin/python3
import os
import re

# Hardware can report the NIC's as different names as a result of the BIOS so we need to find the name of the actual LAN NIC
# NUC LAN NIC = enp2s0/eno1 lo usb0
NIC = os.popen('ls /sys/class/net').read()
NIC = NIC.split('\n')

NICFOUND = ''
for line in NIC:
    if 'lo' not in line and 'vir' not in line and 'wl' not in line and 'enx' not in line:
        NICFOUND = line
        break

if not NICFOUND:
    quit()

# ifconfig
# eno1: flags=4163<UP,BROADCAST,RUNNING,MULTICAST>  mtu 1500
#        inet 172.30.30.220  netmask 255.255.255.0  broadcast 172.30.30.255
#        inet6 fe80::1e69:7aff:fe0b:7048  prefixlen 64  scopeid 0x20<link>
#        ether 1c:69:7a:0b:70:48  txqueuelen 1000  (Ethernet)
#        RX packets 1522556  bytes 373860247 (356.5 MiB)
#        RX errors 0  dropped 0  overruns 0  frame 0
#        TX packets 899985  bytes 240636446 (229.4 MiB)
#        TX errors 0  dropped 0 overruns 0  carrier 0  collisions 0
#
# enxa0cec851132f: flags=4163<UP,BROADCAST,RUNNING,MULTICAST>  mtu 1500
#        inet 172.30.11.225  netmask 255.255.255.0  broadcast 172.30.11.255
#        inet6 fe80::a2ce:c8ff:fe51:132f  prefixlen 64  scopeid 0x20<link>
#        ether a0:ce:c8:51:13:2f  txqueuelen 1000  (Ethernet)
#        RX packets 165827  bytes 14175008 (13.5 MiB)
#        RX errors 0  dropped 0  overruns 0  frame 0
#        TX packets 812  bytes 87512 (85.4 KiB)
#        TX errors 0  dropped 0 overruns 0  carrier 0  collisions 0

# lo: flags=73<UP,LOOPBACK,RUNNING>  mtu 65536
#        inet 127.0.0.1  netmask 255.0.0.0
#        inet6 ::1  prefixlen 128  scopeid 0x10<host>
#        loop  txqueuelen 1000  (Local Loopback)
#        RX packets 1426  bytes 92904 (90.7 KiB)
#        RX errors 0  dropped 0  overruns 0  frame 0
#        TX packets 1426  bytes 92904 (90.7 KiB)
#        TX errors 0  dropped 0 overruns 0  carrier 0  collisions 0

# ip a
# 1: lo: <LOOPBACK,UP,LOWER_UP> mtu 65536 qdisc noqueue state UNKNOWN group default qlen 1000
#    link/loopback 00:00:00:00:00:00 brd 00:00:00:00:00:00
#    inet 127.0.0.1/8 scope host lo
#       valid_lft forever preferred_lft forever
#    inet6 ::1/128 scope host
#       valid_lft forever preferred_lft forever
# 2: enp1s0: <BROADCAST,MULTICAST,UP,LOWER_UP> mtu 1500 qdisc pfifo_fast state UP group default qlen 1000
#    link/ether a0:1e:0b:11:09:89 brd ff:ff:ff:ff:ff:ff
#    inet 192.168.1.231/24 brd 192.168.1.255 scope global dynamic enp1s0
#       valid_lft 82942sec preferred_lft 82942sec
#    inet6 fe80::a21e:bff:fe11:989/64 scope link
#       valid_lft forever preferred_lft forever
# 4: enxa0cec8511328: <NO-CARRIER,BROADCAST,MULTICAST,UP> mtu 1500 qdisc pfifo_fast state DOWN group default qlen 1000
#    link/ether a0:ce:c8:51:13:28 brd ff:ff:ff:ff:ff:ff
#    inet 169.254.1.1/16 brd 169.254.255.255 scope global enxa0cec8511328
#       valid_lft forever preferred_lft forever
#    inet6 fe80::a2ce:c8ff:fe51:1328/64 scope link
#       valid_lft forever preferred_lft forever

IPADDR = os.popen('ifconfig ' + NICFOUND + ' | grep "inet " | cut -d" " -f10').read()
IPADDR = IPADDR.replace("\n", "")

IPMASK = os.popen('ifconfig ' + NICFOUND + ' | grep "netmask " | cut -d" " -f13').read()
IPMASK = IPMASK.replace("\n", "")

MACADDRESS = os.popen('ifconfig ' + NICFOUND + ' | grep -o -E "([[:xdigit:]]{1,2}:){5}[[:xdigit:]]{1,2}"').read()
MACADDRESS = MACADDRESS.replace("\n", "").upper()


# grep "nameserver" /etc/resolv.conf
# nameserver 172.30.0.2

# grep "nameserver" /etc/resolv.conf
# nameserver 192.168.10.1
# nameserver 192.168.10.1
# listing twice was causing an issue

# IPDNS = os.popen('grep "nameserver" /etc/resolv.conf').read()
# IPDNS = IPDNS.split(" ")
# IPDNS = IPDNS[1]
IPDNS = open('/etc/resolv.conf', "r")
IPDNSFOUND = ''
for line in IPDNS:
    if "nameserver" in line:
        IPDNSFOUND = line.replace("nameserver ", "").replace("\n", "")
        break


# iface eno1 inet dhcp
DHCP = open('/etc/network/interfaces', "r")
DHCP = DHCP.readlines()

DHCPFOUND = ''
for line in DHCP:
    if 'iface ' + NICFOUND + ' inet dhcp' in line:
        DHCPFOUND = 'dhcp'
        break
    if 'iface ' + NICFOUND + ' inet static' in line:
        DHCPFOUND = 'static'
        break


# Kernel IP routing table
# Destination     Gateway         Genmask         Flags   MSS Window  irtt Iface
# 0.0.0.0         172.30.20.1     0.0.0.0         UG        0 0          0 enp2s0
# 172.30.20.0     0.0.0.0         255.255.255.0   U         0 0          0 enp2s0


# Kernel IP routing table
# Destination     Gateway         Genmask         Flags   MSS Window  irtt Iface
# 0.0.0.0         172.30.30.1     0.0.0.0         UG        0 0          0 eno1
# 172.30.11.0     0.0.0.0         255.255.255.0   U         0 0          0 usb0
# 172.30.30.0     0.0.0.0         255.255.255.0   U         0 0          0 eno1

IPGATE = ""

IPNETWORK = os.popen('netstat -nr')
Lines = IPNETWORK.readlines()
for line in Lines:
    if NICFOUND in line and 'UG' in line:
        IPGATE = line[16:]
        IPGATE = IPGATE.split(" ")
        IPGATE = IPGATE[0]
        break

# Dual NIC

USBIPADDR = 'none'
USBIPMASK = 'none'
USBMACADDRESS = 'none'
USBDHCPFOUND = 'none'
USBNETSTATUS = 'none'

USBNICFOUND = ''
for line in NIC:
    if 'lo' not in line and 'vir' not in line and 'wl' not in line and NICFOUND not in line:
        USBNICFOUND = line
        break

if USBNICFOUND:
    USBIPADDR = os.popen('ifconfig ' + USBNICFOUND + ' | grep "inet " | cut -d" " -f10').read()
    USBIPADDR = USBIPADDR.replace("\n", "")

    USBIPMASK = os.popen('ifconfig ' + USBNICFOUND + ' | grep "netmask " | cut -d" " -f13').read()
    USBIPMASK = USBIPMASK.replace("\n", "")

    USBMACADDRESS = os.popen('ifconfig ' + USBNICFOUND + ' | grep -o -E "([[:xdigit:]]{1,2}:){5}[[:xdigit:]]{1,2}"').read()
    USBMACADDRESS = USBMACADDRESS.replace("\n", "").upper()

    for line in DHCP:
        if 'iface ' + USBNICFOUND + ' inet dhcp' in line:
            USBDHCPFOUND = 'dhcp'
            break
        if 'iface ' + USBNICFOUND + ' inet static' in line:
            USBDHCPFOUND = 'static'
            break

    NICSTATUS = os.popen('ip a').read()
    NICSTATUS = NICSTATUS.split('\n')
    for line in NICSTATUS:
        if USBNICFOUND in line:
            m = re.search('state (.+?) group', line)
            USBNETSTATUS = m.group(1)
            break

    LOWER = '0.0.0.0'
    LOWER = LOWER.split('.')
    UPPER = '0.0.0.0'
    UPPER = UPPER.split('.')
    IPADDRTMP = IPADDR.split('.')
    IPMASKTMP = IPMASK.split('.')
    USBIPADDRTMP = USBIPADDR.split('.')
    USBIPMASKTMP = USBIPMASK.split('.')

    if (len(IPADDRTMP) == 4 and len(IPMASKTMP) == 4 and len(USBIPADDRTMP) == 4 and len(USBIPMASKTMP) == 4):

        # apply 2nd NIC blocking rules
        NFTAVAILABLE = False
        NFTRULE = False
        try:
            NFT = os.popen('nft list ruleset', stderr=subprocess.DEVNULL)
            Lines = NFT.readlines()
            NFTAVAILABLE = True
            for line in Lines:
                if 'udp dport 6969' in line:
                    NFTRULE = True
                    break
        except:
            pass

        if NFTAVAILABLE:
            if not NFTRULE:
                os.system('nft add table ip filter')
                os.system('nft add chain ip filter INPUT { type filter hook input priority 0 \; }')
                os.system('nft add rule ip filter INPUT iifname ' + NICFOUND + ' udp dport 6969 drop')
                os.system('nft add rule ip filter INPUT iifname ' + NICFOUND + ' udp dport 10001 drop')
                os.system('nft add rule ip filter INPUT iifname ' + NICFOUND + ' udp dport 10002 drop')
                os.system('nft add rule ip filter INPUT iifname ' + NICFOUND + ' udp dport 10003 drop')
                os.system('nft add rule ip filter INPUT iifname ' + NICFOUND + ' udp dport 10004 drop')
        else:
            RULESFOUND = False
            IPTABLESSTATUS = os.popen('iptables -L INPUT').read()
            IPTABLESSTATUS = IPTABLESSTATUS.split('\n')
            for line in IPTABLESSTATUS:
                if "dpt:6969" in line:
                    RULESFOUND = True
                    break
            if not RULESFOUND:
                os.system('iptables -A INPUT -i ' + NICFOUND + ' -p udp --dport 6969 -j DROP')
                os.system('iptables -A INPUT -i ' + NICFOUND + ' -p udp --dport 10001 -j DROP')
                os.system('iptables -A INPUT -i ' + NICFOUND + ' -p udp --dport 10002 -j DROP')
                os.system('iptables -A INPUT -i ' + NICFOUND + ' -p udp --dport 10003 -j DROP')
                os.system('iptables -A INPUT -i ' + NICFOUND + ' -p udp --dport 10004 -j DROP')

            RULESFOUND = False
            IPTABLESSTATUS = os.popen('iptables -L OUTPUT').read()
            IPTABLESSTATUS = IPTABLESSTATUS.split('\n')
            for line in IPTABLESSTATUS:
                if "dpt:6969" in line:
                    RULESFOUND = True
                    break
            if not RULESFOUND:
                os.system('iptables -A OUTPUT -o ' + NICFOUND + ' -p udp --dport 6969 -j DROP')
                os.system('iptables -A OUTPUT -o ' + NICFOUND + ' -p udp --dport 10001 -j DROP')
                os.system('iptables -A OUTPUT -o ' + NICFOUND + ' -p udp --dport 10002 -j DROP')
                os.system('iptables -A OUTPUT -o ' + NICFOUND + ' -p udp --dport 10003 -j DROP')
                os.system('iptables -A OUTPUT -o ' + NICFOUND + ' -p udp --dport 10004 -j DROP')

        # calculate the new values
        for i in range(4):
            if int(IPMASKTMP[i]) != 255:
                x = 0
                IPRANGE = 256 - int(IPMASKTMP[i])
                while x < int(IPADDRTMP[i]):
                    x = x + IPRANGE
                if x > int(IPADDRTMP[i]):
                    x = x - IPRANGE
                IPADDRTMP[i] = x

        # save the lowest address
        for i in range(4):
            LOWER[i] = IPADDRTMP[i]
        LOWER[3] = LOWER[3] + 1

        for i in range(4):
            if int(IPMASKTMP[i]) != 255:
                x = 255 - int(IPMASKTMP[i])
                x = x + int(IPADDRTMP[i])
                IPADDRTMP[i] = x

        # store the highest address
        for i in range(4):
            UPPER[i] = IPADDRTMP[i]
        UPPER[3] = UPPER[3] - 1

        # check the IP values are within limits
        OUTOFRANGE = False
        for i in range(4):
            if int(USBIPADDRTMP[i]) < int(LOWER[i]) or int(USBIPADDRTMP[i]) > int(UPPER[i]):
                OUTOFRANGE = True
                break

        if OUTOFRANGE:
            IPADDRTMP = IPADDR.split('.')
            # calculate the new values
            for i in range(4):
                if int(USBIPMASKTMP[i]) != 255:
                    x = 0
                    IPRANGE = 256 - int(USBIPMASKTMP[i])
                    while x < int(USBIPADDRTMP[i]):
                        x = x + IPRANGE
                    if x > int(USBIPADDRTMP[i]):
                        x = x - IPRANGE
                    USBIPADDRTMP[i] = x

            # save the lowest address
            for i in range(4):
                LOWER[i] = USBIPADDRTMP[i]
            LOWER[3] = LOWER[3] + 1

            for i in range(4):
                if int(USBIPMASKTMP[i]) != 255:
                    x = 255 - int(USBIPMASKTMP[i])
                    x = x + int(USBIPADDRTMP[i])
                    USBIPADDRTMP[i] = x

            # store the highest address
            for i in range(4):
                UPPER[i] = USBIPADDRTMP[i]
            UPPER[3] = UPPER[3] - 1

            # check the IP values are within limits
            OUTOFRANGE = False
            for i in range(4):
                if int(IPADDRTMP[i]) < int(LOWER[i]) or int(IPADDRTMP[i]) > int(UPPER[i]):
                    OUTOFRANGE = True
                    break

        if not OUTOFRANGE:
            os.system('ifconfig ' + USBNICFOUND + ' down')
            USBNETSTATUS = 'DOWN'

    else:

        USBIPADDR = ''
        USBIPMASK = ''
        USBDHCPFOUND = ''

else:

    USBNICFOUND = 'none'

# remove 2nd NIC blocking rules
    NFTAVAILABLE = False
    NFTRULE = False
    try:
        NFT = os.popen('nft list ruleset', stderr=subprocess.DEVNULL)
        Lines = NFT.readlines()
        NFTAVAILABLE = True
        for line in Lines:
            if 'udp dport 6969' in line:
                NFTRULE = True
                break
    except:
        pass

    if NFTAVAILABLE:
        if NFTRULE:
            os.system('nft delete table ip filter')
    else:
        IPTABLESSTATUS = os.popen('iptables -L INPUT').read()
        IPTABLESSTATUS = IPTABLESSTATUS.split('\n')
        for line in IPTABLESSTATUS:
            if "dpt:6969" in line:
                os.system('iptables -D INPUT -i ' + NICFOUND + ' -p udp --dport 6969 -j DROP')
            if "dpt:10001" in line:
                os.system('iptables -D INPUT -i ' + NICFOUND + ' -p udp --dport 10001 -j DROP')
            if "dpt:10002" in line:
                os.system('iptables -D INPUT -i ' + NICFOUND + ' -p udp --dport 10002 -j DROP')
            if "dpt:10003" in line:
                os.system('iptables -D INPUT -i ' + NICFOUND + ' -p udp --dport 10003 -j DROP')
            if "dpt:10004" in line:
                os.system('iptables -D INPUT -i ' + NICFOUND + ' -p udp --dport 10004 -j DROP')

        IPTABLESSTATUS = os.popen('iptables -L OUTPUT').read()
        IPTABLESSTATUS = IPTABLESSTATUS.split('\n')
        for line in IPTABLESSTATUS:
            if "dpt:6969" in line:
                os.system('iptables -D OUTPUT -o ' + NICFOUND + ' -p udp --dport 6969 -j DROP')
            if "dpt:10001" in line:
                os.system('iptables -D OUTPUT -o ' + NICFOUND + ' -p udp --dport 10001 -j DROP')
            if "dpt:10002" in line:
                os.system('iptables -D OUTPUT -o ' + NICFOUND + ' -p udp --dport 10002 -j DROP')
            if "dpt:10003" in line:
                os.system('iptables -D OUTPUT -o ' + NICFOUND + ' -p udp --dport 10003 -j DROP')
            if "dpt:10004" in line:
                os.system('iptables -D OUTPUT -o ' + NICFOUND + ' -p udp --dport 10004 -j DROP')


if IPADDR:
    FILESTRING = "name1:" + NICFOUND + "\n"
    FILESTRING += "ip1:" + IPADDR + "\n"
    FILESTRING += "sub1:" + IPMASK + "\n"
    FILESTRING += "gateway1:" + IPGATE + "\n"
    FILESTRING += "dns:" + IPDNSFOUND + "\n"
    FILESTRING += "type:" + DHCPFOUND + "\n"
    FILESTRING += "mac:" + MACADDRESS + "\n"
    FILESTRING += "\n"
    FILESTRING += "name2:" + USBNICFOUND + "\n"
    FILESTRING += "ip2:" + USBIPADDR + "\n"
    FILESTRING += "sub2:" + USBIPMASK + "\n"
    FILESTRING += "type2:" + USBDHCPFOUND + "\n"
    FILESTRING += "mac2:" + USBMACADDRESS + "\n"
    FILESTRING += "status2:" + USBNETSTATUS + "\n"
    FILENAME = "/opt/director/infoData"
    FILE = open(FILENAME, "w")
    FILE.write(FILESTRING)
    FILE.close()
