create table DBCONFIG(version int);

create table REPORT
(
    ID BIGINT GENERATED BY DEFAULT AS IDENTITY PRIMARY KEY,
    DATETIME BIGINT not null,
    TYPE VARCHAR(100),
    SOURCE VARCHAR(50),
    DESTINATION VARCHAR(50),
    SOURCE_MAC VARCHAR(50),
    DESTINATION_MAC VARCHAR(50),
    COMMAND VARCHAR(2000),
    SOURCE_VIDEO_INPUT VARCHAR(50),
    SOURCE_VIDEO_DETECTED BOOLEAN,
    SOURCE_VIDEO_WIDTH INTEGER,
    SOURCE_VIDEO_HEIGHT INTEGER,
    SOURCE_VIDEO_STATUS_FPS INTEGER,
    SOURCE_VIDEO_SCANMODE VARCHAR(50),
    SOURCE_MAIN_VIDEO_STREAM_STATUS VARCHAR(50),
    SOURCE_MAIN_HDMI_AUDIO_STREAM_STATUS VARCHAR(50),
    SOURCE_MAIN_ANALOG_AUDIO_STREAM_STATUS VARCHAR(50),
    SOURCE_SCALER_STATUS_WIDTH INTEGER,
    SOURCE_SCALER_STATUS_HEIGHT INTEGER,
    SOURCE_SCALER_STATUS_FPS INTEGER,
    SOURCE_SCALER_FRAME_RATE_CONVERTER INTEGER,
    SOURCE_SCALER_VIDEO_STREAM_STATUS VARCHAR(50),
    ANALOG_AUDIO_DIRECTION VARCHAR(50),
    DESTINATION_VIDEO_STATUS_MODE VARCHAR(50),
    DESTINATION_VIDEO_STATUS_WIDTH INTEGER,
    DESTINATION_VIDEO_STATUS_HEIGHT INTEGER,
    DESTINATION_VIDEO_FPS INTEGER,
    DESTINATION_DISPLAY_DETECTED BOOLEAN,
    DESTINATION_ANALOG_AUDIO_OUTPUT_SIGNAL_SOURCE VARCHAR(50),
    DESTINATION_HDMI_AUDIO_OUTPUT_SIGNAL_SOURCE VARCHAR(50),
    DESTINATION_DEVICE_STATUS VARCHAR(50)
);

create index REPORT_DATE_INDEX ON REPORT (DATETIME);

create index REPORT_SOURCE_IDX ON REPORT (SOURCE);

create index REPORT_TYPE_IDX ON REPORT (TYPE);

