#!/usr/bin/python3
import os
import os.path
import socket
import re
import json

# must = either False or True
LIBERTY = True


def is_json(myjson):
  try:
    json.loads(myjson)
  except ValueError as e:
    return False
  return True

# check if backup file exists
if os.path.isfile('/opt/director/config.bak'):
    # read backup file
    with open('/opt/director/config.bak', 'r') as file:
        filedata = file.read()
    # check backup file is valid json
    if is_json(filedata):
        # if valid json delete the config file
        if os.path.isfile('/opt/director/config.json'):
            os.remove('/opt/director/config.json')
        # copy the backup file as the config file
        os.system('cp /opt/director/config.bak /opt/director/config.json')

else:

    # NUC LAN NIC = enp2s0
    NIC = os.popen('ip a').read()
    NIC = NIC.split('\n')
    NICFOUND = ''
    USBNICFOUND = ''
    NICID = 1
    for line in NIC:
        if str(NICID) + ': ' in line:
            if 'lo' not in line and 'vir' not in line and 'wl' not in line:
                m = re.search(str(NICID) + ': (.+?):', line)
                if NICFOUND:
                    USBNICFOUND = m.group(1)
                    break
                else:
                    NICFOUND = m.group(1)
            NICID = NICID + 1

    if NICFOUND:

        IPADDR = os.popen('ifconfig ' + NICFOUND + ' | grep "inet " | cut -d" " -f10').read()
        IPADDR = IPADDR.replace("\n", "")

        IPMASK = os.popen('ifconfig ' + NICFOUND + ' | grep "netmask " | cut -d" " -f13').read()
        IPMASK = IPMASK.replace("\n", "")

        if not IPADDR:
            if USBNICFOUND:
                IPADDR = "192.168.1.1"
                IPMASK = "255.255.255.0"
            else:
                IPADDR = "169.254.1.1"
                IPMASK = "255.255.0.0"

        IPDNS = open('/etc/resolv.conf', "r")
        IPDNSFOUND = '8.8.8.8'
        for line in IPDNS:
            if "nameserver" in line:
                IPDNSFOUND = line.replace("nameserver ", "").replace("\n", "")
                break
        IPDNS.close()

        if USBNICFOUND:
            IPGATE = "192.168.1.254"
        else:
            IPGATE = "169.254.1.254"
        IPNETWORK = os.popen('netstat -nr')
        Lines = IPNETWORK.readlines()
        for line in Lines:
            if NICFOUND in line and 'UG' in line:
                IPGATE = line[16:]
                IPGATE = IPGATE.split(" ")
                IPGATE = IPGATE[0]
                break
        IPNETWORK.close()

        DHCP = open('/etc/network/interfaces', "r")
        Lines = DHCP.readlines()
        DHCPFOUND = 'false'
        for line in Lines:
            if 'iface ' + NICFOUND + ' inet dhcp' in line:
                DHCPFOUND = 'true'
                break
        DHCP.close()

    else:

        DHCPFOUND = 'false'
        IPDNSFOUND = '8.8.8.8'
        if USBNICFOUND:
            IPADDR = "192.168.1.1"
            IPMASK = "255.255.255.0"
            IPGATE = "192.168.1.254"
        else:
            IPADDR = "169.254.1.1"
            IPMASK = "255.255.0.0"
            IPGATE = "169.254.1.254"

    if USBNICFOUND:
        USBIPADDR = os.popen('ifconfig ' + USBNICFOUND + ' | grep "inet " | cut -d" " -f10').read()
        USBIPADDR = USBIPADDR.replace("\n", "")

        USBIPMASK = os.popen('ifconfig ' + USBNICFOUND + ' | grep "netmask " | cut -d" " -f13').read()
        USBIPMASK = USBIPMASK.replace("\n", "")

        if not USBIPADDR:
            USBIPADDR = "169.254.1.1"
            USBIPMASK = "255.255.0.0"

    FILESTRING = '{'
    FILESTRING += '  "logLevel" : "INFO",\n'
    FILESTRING += '  "logConsole" : true,\n'
    FILESTRING += '  "devices.dataRefreshTime" : 30000,\n'
    FILESTRING += '  "devices.statusRefreshTime" : 5000,\n'
    if LIBERTY:
        FILESTRING += '  "layout.file" : "liberty.json",\n'
    else:
        FILESTRING += '  "layout.file" : "default.json",\n'
    FILESTRING += '  "devices.udpWaitTimeout" : 250,\n'
    FILESTRING += '  "devices.telnetTimeout" : -1,\n'
    FILESTRING += '  "devices.loginDelay" : 1000,\n'
    FILESTRING += '  "devices.telnetReadTimeout" : 3000,\n'
    FILESTRING += '  "devices.telnetBusyTimeout" : 3000,\n'
    FILESTRING += '  "matrix.subscriptionFetchInitialDelay" : 500,\n'
    FILESTRING += '  "matrix.subscriptionFetchDelay" : 500,\n'
    FILESTRING += '  "matrix.subscriptionFetchCount" : 5,\n'
    FILESTRING += '  "identify.onOffInterval" : 30,\n'
    FILESTRING += '  "consoleConnections" : 0,\n'
    FILESTRING += '  "leaveSubscriptionsSystemStart" : false,\n'
    FILESTRING += '  "defaultMulticastRangeStart" : 239,\n'
    FILESTRING += '  "multicast.rangeStart" : 239,\n'
    FILESTRING += '  "restart" : "/opt/director/restart.sh",\n'
    FILESTRING += '  "reboot" : "/opt/director/reboot.sh",\n'
    FILESTRING += '  "generateInfoFile" : "/opt/director/info.sh",\n'
    FILESTRING += '  "infoFilePath" : "/opt/director/infoData",\n'
    FILESTRING += '  "setInfoFile" : "/opt/director/config.sh",\n'
    FILESTRING += '  "deleteInfoFile" : "/opt/director/delete.sh",\n'
    FILESTRING += '  "testDhcpFilePath" : "/opt/director/testDHCP.sh",\n'
    FILESTRING += '  "testDhcpOutputFilePath" : "/opt/director/infoDHCP",\n'
    FILESTRING += '  "defaultDhcp" : false,\n'
    if LIBERTY:
        FILESTRING += '  "defaultHostname" : "Arranger",\n'
    else:
        FILESTRING += '  "defaultHostname" : "Director",\n'
    FILESTRING += '  "rebootTime" : 90,\n'
    FILESTRING += '  "directorRestartTime" : 20,\n'
    FILESTRING += '  "oemNamePrefixMap" : {\n'
    if LIBERTY:
        FILESTRING += '    "IPE5000DNT" : "IPEX5001-D",\n'
        FILESTRING += '    "IPE5000" : "IPEX5001",\n'
        FILESTRING += '    "IPD5000" : "IPEX5002",\n'
        FILESTRING += '    "IPE5000W" : "IPEX5001-WP"\n'
    else:
        FILESTRING += '    "IPE5000DNT" : "TH2001DTE",\n'
        FILESTRING += '    "IPE5000" : "TH2001E",\n'
        FILESTRING += '    "IPD5000" : "TH2002D",\n'
        FILESTRING += '    "IPE5000W" : "TH2001WP"\n'
    FILESTRING += '  },\n'
    FILESTRING += '  "validModels" : [ "IPE5000", "IPD5000", "IPE5000DNT", "IPE5000W" ],\n'
    FILESTRING += '  "inactiveSessionTimeout" : 15,\n'
    FILESTRING += '  "serial_timeout" : 3000,\n'
    FILESTRING += '  "tcpSecured" : false,\n'
    FILESTRING += '  "tcpConnectionTimeout" : 120,\n'
    FILESTRING += '  "tcp_command_timeout" : 3000,\n'
    FILESTRING += '  "tcp_command_timeout_gap" : "300",\n'
    FILESTRING += '  "gc_command_timeout" : 5000,\n'
    FILESTRING += '  "gc_command_timeout_gap" : "500",\n'
    FILESTRING += '  "ntp" : "/opt/director/ntp.sh",\n'
    FILESTRING += '  "setNtp" : "/opt/director/set-ntp.sh",\n'
    FILESTRING += '  "setTime" : "/opt/director/time.sh",\n'
    FILESTRING += '  "dbRetentionPeriod" : 1,\n'
    FILESTRING += '  "firmwareUpdateMaxDeviceCount" : 50,\n'
    FILESTRING += '  "bezelLimit" : 20,\n'
    FILESTRING += '  "vw_defaultHeightWidthRatio" : 0.5,\n'
    FILESTRING += '  "vw_minWidth" : 500.0,\n'
    FILESTRING += '  "email_settings" : {\n'
    FILESTRING += '    "port" : 25,\n'
    FILESTRING += '    "emailTo" : "",\n'
    FILESTRING += '    "emailCc" : "",\n'
    FILESTRING += '    "mailServer" : "",\n'
    FILESTRING += '    "fromEmail" : "",\n'
    FILESTRING += '    "userName" : "",\n'
    FILESTRING += '    "password" : "",\n'
    FILESTRING += '    "secureConnection" : false,\n'
    FILESTRING += '    "authentication" : "NONE"\n'
    FILESTRING += '  },\n'
    FILESTRING += '  "customURL" : false,\n'
    FILESTRING += '  "debounce" : "100",\n'
    if LIBERTY:
        FILESTRING += '  "dateFormat" : "MM-dd-yyyy",\n'
    else:
        FILESTRING += '  "dateFormat" : "dd-MM-yyyy",\n'
    FILESTRING += '  "timeFormat" : "24H",\n'
    FILESTRING += '  "deviceNameMaxLength" : 23,\n'
    FILESTRING += '  "jpgImagePreview" : true,\n'
    FILESTRING += '  "previewCacheInterval" : 10,\n'
    if USBNICFOUND:
        FILESTRING += '  "apiControllerIp" : "' + IPADDR + '",\n'
        FILESTRING += '  "apiControllerSubnet" : "' + IPMASK + '",\n'
        FILESTRING += '  "apiControllerGateway" : "' + IPGATE + '",\n'
        FILESTRING += '  "defaultIpAddr" : "192.168.1.1",\n'
        FILESTRING += '  "defaultGateway" : "192.168.1.254",\n'
        FILESTRING += '  "defaultMask" : "255.255.255.0",\n'
        FILESTRING += '  "apiControllerIp2" : "' + USBIPADDR + '",\n'
        FILESTRING += '  "apiControllerSubnet2" : "' + USBIPMASK + '",\n'
        FILESTRING += '  "defaultIpAddr2" : "169.254.1.1",\n'
        FILESTRING += '  "defaultMask2" : "255.255.0.0",\n'
    else:
        FILESTRING += '  "apiControllerIp" : "' + IPADDR + '",\n'
        FILESTRING += '  "apiControllerSubnet" : "' + IPMASK + '",\n'
        FILESTRING += '  "apiControllerGateway" : "' + IPGATE + '",\n'
        FILESTRING += '  "defaultIpAddr" : "169.254.1.1",\n'
        FILESTRING += '  "defaultGateway" : "169.254.1.254",\n'
        FILESTRING += '  "defaultMask" : "255.255.0.0",\n'
    FILESTRING += '  "defaultDns" : "8.8.8.8",\n'
    FILESTRING += '  "apiControllerDns" : "' + IPDNSFOUND + '",\n'
    FILESTRING += '  "apiControllerDHCP" : "' + DHCPFOUND + '",\n'
    FILESTRING += '  "companyName" : "",\n'
    FILESTRING += '  "registrationKey" : "",\n'
    FILESTRING += '  "language" : "en"\n'
    FILESTRING += '}\n'
    FILESTRING += '\n'

    FILENAME = '/opt/director/config.json'
    FILE = open(FILENAME, 'w')
    FILE.write(FILESTRING)
    FILE.close()

    os.system('cp /opt/director/config.json /opt/director/config.bak')
