#!/usr/bin/python3
import os
import subprocess
import re

# Hardware can report the NIC's as different names as a result of the BIOS so we need to find the name of the actual LAN NIC
# NUC LAN NIC = enp2s0/eno1 lo usb0
NIC = os.popen('ls /sys/class/net').read()
NIC = NIC.split('\n')

NICFOUND = ''
for line in NIC:
    if 'lo' not in line and 'vir' not in line and 'wl' not in line and 'enx' not in line:
        NICFOUND = line
        break

# dhclient -v -4 eno1
# Internet Systems Consortium DHCP Client 4.4.1
# Copyright 2004-2018 Internet Systems Consortium.
# All rights reserved.
# For info, please visit https://www.isc.org/software/dhcp/

# Listening on LPF/eno1/1c:69:7a:0b:70:48
# Sending on   LPF/eno1/1c:69:7a:0b:70:48
# Sending on   Socket/fallback
# DHCPREQUEST for 172.30.30.220 on eno1 to 255.255.255.255 port 67
# DHCPACK of 172.30.30.220 from 172.30.30.1
# RTNETLINK answers: File exists
# bound to 172.30.30.220 -- renewal in 39714 seconds.

DHCPIPFOUND = ''
IPADDR = ''

if NICFOUND:
    IPADDR = os.popen('ifconfig ' + NICFOUND + ' | grep "inet " | cut -d" " -f10').read()
    IPADDR = IPADDR.replace("\n","")
    DHCP = open('/etc/network/interfaces', "r")
    DHCP = DHCP.readlines()
    for line in DHCP:
        if 'iface ' + NICFOUND + ' inet dhcp' in line:
            DHCPIPFOUND = IPADDR
            break
        if 'iface ' + NICFOUND + ' inet static' in line:
            break

    if not DHCPIPFOUND:
        process = subprocess.Popen(['dhclient', '-v', '-4', NICFOUND], stdout=subprocess.PIPE, stderr=subprocess.PIPE)
        stdout, stderr = process.communicate()
# NOTE must use stderr not stdout ???
        FILE = stderr.decode('utf-8')
        FILE = FILE.split('\n')

        for line in FILE:
            if "DHCPACK" in line:
                m = re.search('DHCPACK of (.+?) from', line)
                DHCPIPFOUND = m.group(1)
                if IPADDR != DHCPIPFOUND:
                    NIC = os.popen('ip a').read()
                    NIC = NIC.split('\n')
                    for line in NIC:
                        if 'inet ' + DHCPIPFOUND in line:
                            m = re.search('inet (.+?) brd', line)
                            DHCPIPDELETE = m.group(1)
                            os.system('ip address del ' + DHCPIPDELETE + ' dev ' + NICFOUND)
                            break
                break

if DHCPIPFOUND:
    FILESTRING = "dhcp_address:" + DHCPIPFOUND + "\n"
else:
    FILESTRING = "dhcp_address:none\n"

FILENAME = "/opt/director/infoDHCP"
FILE = open(FILENAME, "w")
FILE.write(FILESTRING)
FILE.close()
