#!/bin/bash

# Add USB Reset

# Check if required
if crontab -l | grep -q '/opt/director/monitor.sh'
  then
# Install Package
dpkg -i /opt/director/python3-pyudev_0.21.0-1_all.deb
sleep 15

# Remove monitor.sh and add monitorUSB.sh to crontab
# crontab -l | grep -v "@reboot sleep 35; sudo /opt/director/monitor.sh" | crontab -
cat <(crontab -l) <(echo "@reboot sleep 35; sudo /opt/director/monitorUSB.sh") | crontab -

# Update cronjob defaults
update-rc.d cron defaults

# Remove monitor.sh and python3-pyudev package
# rm /opt/director/monitor.sh
rm /opt/director/python3-pyudev_0.21.0-1_all.deb

# Remove completed commands
sed -i '3,38d' /opt/director/updates.sh

# Reboot Controller
reboot

  else
# Remove redundant files
rm /opt/director/monitor.sh
rm /opt/director/AddUSBReset.sh
rm /opt/director/python3-pyudev_0.21.0-1_all.deb
# Remove everything from this section of the script
sed -i '3,38d' /opt/director/updates.sh

fi

# Add updates.sh to crontab if required

if crontab -l | grep -q '/opt/director/updates.sh'
  then
# Remove everything from this section of the script
sed -i '3,24d' /opt/director/updates.sh

  else
# Add updates.sh to crontab
cat <(crontab -l) <(echo "@reboot sleep 35; sudo /opt/director/updates.sh") | crontab -

# Update cronjob defaults
update-rc.d cron defaults

# Remove completed commands
sed -i '3,24d' /opt/director/updates.sh

# Reboot Controller
reboot

fi

# Clean updates.sh trigger from start.sh and remove completed command
sed -i '/updates.sh/d' /opt/director/start.sh
sed -i '3,6d' /opt/director/updates.sh

# Update Director files
# Stop Director
/opt/director/stop.sh

# Replace validModels
sed -i 's/\"validModels\".*/\"validModels\" : \[ \"IPE5000\", \"IPD5000\", \"IPE5000DNT\", \"IPE5000W\" \],/' /opt/director/config.json

# Remove updated lib files
if [ -e /opt/director/lib/commons-text-1.1.jar ] && [ -e /opt/director/lib/commons-text-1.8.jar ]
  then rm /opt/director/lib/commons-text-1.1.jar
fi

# Start Director
/opt/director/start.sh

# Remove Completed Commands
sed -i '3,20d' /opt/director/updates.sh



